/* ------------------------- ODBC2.cpp ---------------------------- */
#include <afxwin.h>
#include <afxext.h>
#include <afxdb.h>
#include "resource.h"

class MyRecordset:public CRecordset
{
public:
	long MyPasteID;
	CString MyPasteName;
	DECLARE_DYNAMIC(MyRecordset)
	MyRecordset(CDatabase *pDatabase=NULL):CRecordset(pDatabase)
	{
		AfxMessageBox("MyRecordset\nConstructor");
		m_nFields=2;
		MyPasteID=0;
		MyPasteName=_T(" ");
		m_nDefaultType=dynaset;
	}

	CString GetDefaultConnect()
	{
		AfxMessageBox("GetDefaultConnect");
		return _T("ODBC;DSN=paste");
	}

	CString GetDefaultSQL()
	{		
		AfxMessageBox("GetDefaultSQL");
		return _T("[master]");
	}

	void DoFieldExchange(CFieldExchange *pFX)
	{
		AfxMessageBox("DoFieldExchange");
		pFX->SetFieldType(CFieldExchange::outputColumn);
		RFX_Long(pFX,_T("[id]"),MyPasteID);
		RFX_Text(pFX,_T("[name]"),MyPasteName);
	}
};
IMPLEMENT_DYNAMIC(MyRecordset,CRecordset)

class MyDocument:public CDocument
{
public:
	MyRecordset m_odbcSet;
	DECLARE_DYNCREATE(MyDocument)
};
IMPLEMENT_DYNCREATE(MyDocument,CDocument)

class MyRecordView:public CRecordView
{
public:
	DECLARE_DYNCREATE(MyRecordView);
	MyRecordset *m_pSet;

	MyDocument* GetDocument()
	{
		AfxMessageBox("GetDocument");
		return (MyDocument*)m_pDocument;
	}

	MyRecordView():CRecordView(IDD_DIALOG1)
	{
		AfxMessageBox("View Constructor");
		m_pSet=NULL;
	}


	CRecordset* OnGetRecordset()
	{
		AfxMessageBox("OnGetRecordset");
		return m_pSet;
	}

	void DoDataExchange(CDataExchange *pDX)
	{
		AfxMessageBox("DoDataExchange");
		DDX_FieldText(pDX,ID_EDIT1,m_pSet->MyPasteID,m_pSet);
		DDX_FieldText(pDX,ID_EDIT2,m_pSet->MyPasteName,m_pSet);
	}

	void OnInitialUpdate()
	{
		AfxMessageBox("OnInitialUpdate");
		m_pSet=&GetDocument()->m_odbcSet;
		m_pSet->Open();
	}
	void first();
	void last();
	void next();
	void prev();
	void clear();
	void add();
	void mod();
	void del();
	DECLARE_MESSAGE_MAP()
};
BEGIN_MESSAGE_MAP(MyRecordView,CRecordView)
	ON_COMMAND(ID_FIRST,first)
	ON_COMMAND(ID_LAST,last)
	ON_COMMAND(ID_PREV,prev)
	ON_COMMAND(ID_NEXT,next)
	ON_BN_CLICKED(ID_CLEAR,clear)
	ON_BN_CLICKED(ID_ADD,add)
	ON_BN_CLICKED(ID_MODIFY,mod)
	ON_BN_CLICKED(ID_DELETE,del)
END_MESSAGE_MAP()
IMPLEMENT_DYNCREATE(MyRecordView,CRecordView)

void MyRecordView::first()
{
	m_pSet->MoveFirst();
	UpdateData(FALSE);
}

void MyRecordView::last()
{
	m_pSet->MoveLast();
	UpdateData(FALSE);
}

void MyRecordView::prev()
{
	m_pSet->MovePrev();
	if(m_pSet->IsBOF())
	{
		AfxMessageBox("No More Record in this direction");
		m_pSet->MoveFirst();
	
	}
	UpdateData(FALSE);
}

void MyRecordView::next()
{
	if(m_pSet->IsEOF())
	{
		AfxMessageBox("No More Record in this direction");
		return;
	}
	m_pSet->MoveNext();
	UpdateData(FALSE);
}

void MyRecordView::clear()
{
	m_pSet->SetFieldNull(NULL);
	UpdateData(FALSE);
}

void MyRecordView::add()
{
	if(!m_pSet->IsEOF())
		m_pSet->MoveLast();

		m_pSet->AddNew();
		UpdateData(TRUE);
		if(!m_pSet->Update())
		{
			AfxMessageBox("Could not add the record");
			return;
		}
		AfxMessageBox("Record Added");
		m_pSet->Requery();
		UpdateData(FALSE);
}

void MyRecordView::mod()
{
	
	m_pSet->Edit();
	UpdateData(TRUE);
	if(!m_pSet->Update())
	{
		AfxMessageBox("Could not modify the record");
		return;
	}
	AfxMessageBox("Record Modified");
	m_pSet->Requery();
	UpdateData(FALSE);
}

void MyRecordView::del()
{
	m_pSet->Delete();
	m_pSet->MoveNext();
	if(m_pSet->IsEOF())
		m_pSet->MoveLast();

	if(m_pSet->IsEOF())
		m_pSet->SetFieldNull(NULL);
	UpdateData(FALSE);
}

class MyWindow:public CFrameWnd
{
public:
	CToolBar tb;
	MyWindow();
	DECLARE_DYNCREATE(MyWindow)
};
IMPLEMENT_DYNCREATE(MyWindow,CFrameWnd)

MyWindow::MyWindow()
{
	AfxMessageBox("MyWindow Constructor");
	tb.Create(this,WS_CHILD|WS_VISIBLE|CBRS_TOP|CBRS_TOOLTIPS|CBRS_FLYBY);
	tb.LoadToolBar(MAKEINTRESOURCE(IDR_TOOLBAR1));
}

class MyApp:public CWinApp
{
public:
	int InitInstance()
	{
		AfxMessageBox("InitInstance");
		CSingleDocTemplate *DocTemplate;
		CRuntimeClass *Docptr,*Frameptr,*Viewptr;
		
		Docptr=RUNTIME_CLASS(MyDocument);
		Frameptr=RUNTIME_CLASS(MyWindow);
		Viewptr=RUNTIME_CLASS(MyRecordView);

		DocTemplate=new CSingleDocTemplate(IDR_MENU1,Docptr,Frameptr,Viewptr);
		AddDocTemplate(DocTemplate);
		OnFileNew();
		return 1;
	}

	void ExitFunc()
	{
		PostQuitMessage(0);
	}
	DECLARE_MESSAGE_MAP()
};
BEGIN_MESSAGE_MAP(MyApp,CWinApp)
	ON_COMMAND(ID_FILE_NEW,OnFileNew)
	ON_COMMAND(ID_EXIT,ExitFunc)
END_MESSAGE_MAP()

MyApp TheApp;