/* ------------------------- ODBC1.cpp ---------------------------- */
#include <afxwin.h>
#include <afxext.h>
#include <afxdb.h>
#include "resource.h"

class MyRecordset:public CRecordset
{
public:
	long MyPasteID;
	CString MyPasteName;
	DECLARE_DYNAMIC(MyRecordset)
	MyRecordset(CDatabase *pDatabase=NULL):CRecordset(pDatabase)
	{
		m_nFields=2;
		MyPasteID=0;
		MyPasteName=_T(" ");
		m_nDefaultType=snapshot;
	}

	CString GetDefaultConnect()
	{
		return _T("ODBC;DSN=paste");
	}

	CString GetDefaultSQL()
	{		
		return _T("[master]");
	}

	void DoFieldExchange(CFieldExchange *pFX)
	{
		pFX->SetFieldType(CFieldExchange::outputColumn);
		RFX_Long(pFX,_T("[id]"),MyPasteID);
		RFX_Text(pFX,_T("[name]"),MyPasteName);
	}
};
IMPLEMENT_DYNAMIC(MyRecordset,CRecordset)

class MyDocument:public CDocument
{
public:
	MyRecordset m_odbcSet;
	DECLARE_DYNCREATE(MyDocument)
};
IMPLEMENT_DYNCREATE(MyDocument,CDocument)

class MyScrollView:public CScrollView
{
protected:
	DECLARE_DYNCREATE(MyScrollView);
	MyRecordset *m_pSet;
public:
	MyDocument *GetDocument()
	{
		return (MyDocument *) m_pDocument;
	}

	void OnInitialUpdate()
	{
		CScrollView::OnInitialUpdate();
		CSize sizeTotal(8000,10500);
		SetScrollSizes(MM_HIENGLISH,sizeTotal);
		m_pSet=&GetDocument()->m_odbcSet;

		if(m_pSet->IsOpen())
			m_pSet->Close();
		m_pSet->Open();
	}

	void OnDraw(CDC *pDC)
	{
		int y=0;
		CString str;
		m_pSet->MoveFirst();
		if(m_pSet->IsEOF())
		{
			AfxMessageBox("EmptyRecordset");
			return;
		}

		while(!m_pSet->IsEOF())
		{
			str.Format("%ld",m_pSet->MyPasteID);
			pDC->TextOut(100,y,str);
			pDC->TextOut(500,y,m_pSet->MyPasteName);
			m_pSet->MoveNext();
			y-=400;
		}
		
	}
};
IMPLEMENT_DYNCREATE(MyScrollView,CScrollView)

class MyWindow:public CFrameWnd
{
public:
	DECLARE_DYNCREATE(MyWindow)
};
IMPLEMENT_DYNCREATE(MyWindow,CFrameWnd)

class MyApp:public CWinApp
{
public:
	int InitInstance()
	{
		CSingleDocTemplate *DocTemplate;
		CRuntimeClass *Docptr,*Frameptr,*Viewptr;
		
		Docptr=RUNTIME_CLASS(MyDocument);
		Frameptr=RUNTIME_CLASS(CFrameWnd);
		Viewptr=RUNTIME_CLASS(MyScrollView);

		DocTemplate=new CSingleDocTemplate(IDR_MENU1,Docptr,Frameptr,Viewptr);
		AddDocTemplate(DocTemplate);
		OnFileNew();
		return 1;
	}

	void ExitFunc()
	{
		PostQuitMessage(0);
	}
	DECLARE_MESSAGE_MAP()
};
BEGIN_MESSAGE_MAP(MyApp,CWinApp)
	ON_COMMAND(ID_QUIT,ExitFunc)
END_MESSAGE_MAP()
MyApp TheApp;